%define name ltp
%define srcver 20080831
%define release %mkrel 1

%define _requires_exceptions perl(.*)
%define _provides_exceptions perl(.*)

Summary: Linux Test Project
Name: %{name}
Version: 0.%srcver
Release: %{release}
Epoch: 1
Source0: http://prdownloads.sourceforge.net/ltp/%{name}-full-%{srcver}.tgz
Patch0:  add_limits_h_to_hackbench_c.patch
Patch1:  fix_dirent_h.patch
License: GPL
Group: Development/Kernel
Requires: /usr/bin/ar /usr/bin/objdump gcc cdialog /usr/bin/ld /usr/bin/ldd tar
BuildRoot: %{_tmppath}/%{name}-buildroot
BuildRequires: flex glibc-static-devel rsync
Url: http://ltp.sourceforge.net/

%description
The Linux Test Project is a joint project with SGI, IBM, OSDL, and Bull with a
goal to deliver test suites to the open source community that validate the 
reliability, robustness, and stability of Linux. The Linux Test Project is a 
collection of tools for testing the Linux kernel and related features. Our goal
is to improve the Linux kernel by bring test automation to the kernel testing 
effort. Interested open source contributors are encouraged to join the project.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -n %name-full-%srcver
%patch0 -p1
%patch1 -p1

%build
perl -p -i -e 's/@\.\/IDcheck\.sh//' Makefile
%make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%_libdir/ltp/testcases/bin
mkdir -p $RPM_BUILD_ROOT%_libdir/ltp/tools
mkdir -p $RPM_BUILD_ROOT%_libdir/ltp/runtest
mkdir -p $RPM_BUILD_ROOT%_libdir/ltp/testscripts
mkdir -p $RPM_BUILD_ROOT%_libdir/ltp/pan/cgi

mkdir -p $RPM_BUILD_ROOT%_mandir/man1/
mkdir -p $RPM_BUILD_ROOT%_mandir/man3/

mkdir -p $RPM_BUILD_ROOT%_bindir

cp -p ChangeLog $RPM_BUILD_ROOT%_libdir/ltp
cp -p runltp *.sh $RPM_BUILD_ROOT%_libdir/ltp
cp -p ltpmenu $RPM_BUILD_ROOT%_libdir/ltp
cp -p ver_linux $RPM_BUILD_ROOT%_libdir/ltp
cp -p pan/{bump,pan,scanner} $RPM_BUILD_ROOT%_libdir/ltp/pan
cp -p pan/cgi/*.cgi $RPM_BUILD_ROOT%_libdir/ltp/pan/cgi
cp -p runtest/[a-z]* $RPM_BUILD_ROOT%_libdir/ltp/runtest
cp -p testscripts/*.sh $RPM_BUILD_ROOT%_libdir/ltp/testscripts

cp -p $RPM_BUILD_DIR/%name-full-%srcver/doc/man1/* $RPM_BUILD_ROOT%_mandir/man1/
cp -p $RPM_BUILD_DIR/%name-full-%srcver/doc/man3/* $RPM_BUILD_ROOT%_mandir/man3/

perl -p -i -e 's/whoami.*/true/' `find . -name \*.sh`
find testcases -type f | xargs perl -p -i -e 's@/usr/local/bin/perl5@/usr/bin/perl@'

# trem: fix path in lib/Makefile
perl -i -pe 's|DESTDIR=/opt/ltp|DESTDIR=%{buildroot}%{_prefix}|g' lib/Makefile
perl -i -pe 's|/usr/share/pkgconfig/ltp.pc|%{buildroot}/usr/share/pkgconfig/ltp.pc|g' lib/Makefile
perl -i -pe 's|/lib/|/%{_lib}/|g' lib/Makefile

# trem: fix path in include/Makefile
perl -i -pe 's|DESTDIR=/opt/ltp|DESTDIR=%{buildroot}%{_libdir}/%{name}|g' include/Makefile

# trem: fix path in pan/Makefile
perl -i -pe 's|DESTDIR = /opt/ltp|DESTDIR=%{buildroot}%{_libdir}/%{name}|g' pan/Makefile

# trem: fix path in doc/man1/Makefile and doc/man3/Makefile
perl -i -pe 's|DESTDIR=/usr|DESTDIR=%{buildroot}%{_libdir}/%{name}|g' doc/man1/Makefile
perl -i -pe 's|DESTDIR=/usr|DESTDIR=%{buildroot}%{_libdir}/%{name}|g' doc/man3/Makefile

%makeinstall 

rsync -ar --exclude="*.c" --exclude="*.h" --exclude=Makefile tools/ $RPM_BUILD_ROOT%_libdir/ltp/tools
rsync -ar --exclude="*.c" --exclude="*.h" --exclude=Makefile testcases/ $RPM_BUILD_ROOT%_libdir/ltp/testcases

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README CREDITS doc/*.txt
%doc doc/examples doc/*.lyx
%doc doc/testcases
%_datadir/pkgconfig/%{name}.pc
%_libdir/ltp
%_libdir/libltp.a
%_mandir/man1/*
%_mandir/man3/*


%changelog
* Mon Sep 08 2008 trem <trem@mandriva.org> 1:0.20080831-1mdv2009.0
+ Revision: 282825
- add patch fix_dirent_h.patch that change #include <linux/dirent.h> to #include <dirent.h>
- update to 20080831

* Thu Jul 31 2008 trem <trem@mandriva.org> 1:0.20080731-1mdv2009.0
+ Revision: 258519
- update to 20080731

* Thu Jul 10 2008 trem <trem@mandriva.org> 1:0.20080630-1mdv2009.0
+ Revision: 233602
- add patch to fix the compilation of hackbench
- update to 20080630
- update to 20080331

* Sat Mar 01 2008 trem <trem@mandriva.org> 1:0.20080229-1mdv2008.1
+ Revision: 177033
- update to 20080229

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix description-line-too-long

* Sat Feb 09 2008 trem <trem@mandriva.org> 1:0.20080131-1mdv2008.1
+ Revision: 164602
- update to 20080131

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Aug 29 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1:0.20070731-1mdv2008.0
+ Revision: 74607
- Updated to 20070731.
- Added needed BuildRequires for glibc-static-devel.
- Move ChangeLog to _libdir/ltp, it's required by runltp.

* Thu May 03 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1:0.20070430-1mdv2008.0
+ Revision: 22040
- Updated to release 20070430.


* Thu Jul 14 2005 Frederic Lepied <flepied@mandriva.com> 20050707-1mdk
- New release 20050707

* Wed Mar 09 2005 Frederic Lepied <flepied@mandrakesoft.com> 20050307-1mdk
- New release 20050307

* Fri Feb 11 2005 Frederic Lepied <flepied@mandrakesoft.com> 20050207-1mdk
- New release 20050207

* Thu Jan 13 2005 Frederic Lepied <flepied@mandrakesoft.com> 20050107-1mdk
- New release 20050107

* Thu Dec 23 2004 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 0.20041203-3mdk
- Remove all perl requires as well, since it comes with all required modules
  bundled in a private directory.

* Thu Dec 23 2004 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 0.20041203-2mdk
- Do not provide any perl module, since they're not installed in the standard
  location (@INC)

* Thu Dec 16 2004 Mandrakelinux Team <http://www.mandrakeexpert.com> 20041203-1mdk
- New release 20041203

* Sun Feb 15 2004 Frederic Lepied <flepied@mandrakesoft.com> 0.20040206-1mdk
- 2004/02/06 version

* Sun Nov 09 2003 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 0.20031002-1mdk
- 20031002
- Add test scripts directory in the rpm package
- Add the full testcases directory because some needed files were missing
- Remove execution of IDcheck.sh from the Makefile

* Tue May 06 2003 Frederic Lepied <flepied@mandrakesoft.com> 0.20030404-2mdk
- rebuild

* Mon May 05 2003 Frederic Lepied <flepied@mandrakesoft.com> 0.20030404-1mdk
- 20030404

* Mon May 05 2003 Lenny Cartier <lenny@mandrakesoft.com> 0.20030206-2mdk
- buildrequires

* Fri Feb 07 2003 Lenny Cartier <lenny@mandrakesoft.com> 0.20030206-1mdk
- 20030206

* Wed Jan 15 2003 Lenny Cartier <lenny@mandrakesoft.com> 0.20030110-1mdk
- 20030110

* Mon Oct 14 2002 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.20021008-1mdk
- 20021008

* Mon Oct 14 2002 Thierry Vignaud <tvignaud@mandrakesoft.com> 20021008-1mdk
- fix version

* Wed Oct 09 2002 Lenny Cartier <lenny@mandrakesoft.com> 10.08.02-1mdk
- 10.08.02

* Wed Sep 11 2002 Lenny Cartier <lenny@mandrakesoft.com> 9.10.02-1mdk
- 9.10.02

* Thu Jul 11 2002 Lenny Cartier <lenny@mandrakesoft.com> 7.9.02-1mdk
- 7.9.02

* Tue Jun 11 2002 Lenny Cartier <lenny@mandrakesoft.com> 0-0.20020607.1mdk
- 20020607

* Fri Jan 11 2002 Lenny Cartier <lenny@mandrakesoft.com> 0-0.20020108.1mdk
- 20020108

* Fri Dec 07 2001 Lenny Cartier <lenny@mandrakesoft.com> 0-0.20011206.1mdk
- updated to 20011206
- move manpages

* Wed Sep 26 2001 Frederic Lepied <flepied@mandrakesoft.com> 0-0.20010925.1mdk
- first Mandrake Linux version

